/*____________________________________________________________________________
        
        Zinf - Zinf Is Not FreeA*p (The Free MP3 Player)
        Portions copyright (C) 1999-2000 EMusic.com

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        
        $Id: cdpmo.h,v 1.4 2003/02/13 11:47:59 rottmann Exp $
____________________________________________________________________________*/

#ifndef INCLUDED_CDPMO_H_
#define INCLUDED_CDPMO_H_

/* system headers */
#include <stdlib.h>
#include <string>
#include <vector>

/* project headers */
#include "config.h"
#include "thread.h"
#include "mutex.h"
#include "pmo.h"
#include "pmoevent.h"
#include "eventbuffer.h"

enum
{
   pmoError_MinimumError = 4000,
   pmoError_DeviceOpenFailed,
   pmoError_MaximumError
};

class FAContext;

class CDPMO:public PhysicalMediaOutput
{
 public:

            CDPMO(FAContext *context);
   virtual ~CDPMO();

   virtual Error Init(OutputInfo * info);
   static  void  StartWorkerThread(void *);
   virtual void  GetVolume(int32_t &, int32_t&);
   virtual void  SetVolume(int32_t, int32_t);
   virtual void  Pause(void);
   virtual void  Resume(void);
   virtual Error ChangePosition(int32_t);
   virtual Error SetTo(const char *url); 

   struct disc_info *GetDiscInfo();
   uint32_t  GetCDDBDiscID();
   char   *GetcdindexDiscID();

   void    Eject(void);

 private:
   void          WorkerThread(void); 
   virtual Error Reset(bool user_stop);
   void          HandleTimeInfoEvent(PMOTimeInfoEvent *pEvent);

   bool          m_properlyInitialized;
   Thread       *m_pBufferThread;

   int           m_cdDesc;
   int           m_track;
   bool          sentData;
   bool          trackDone;

   uint32_t           cddbid;
   std::string           cdindexid;
   struct disc_info dinfo;
};

#endif /* _SOUNDCARDPMO_H_ */
