/*____________________________________________________________________________
	
	Zinf - Zinf Is Not FreeA*p (The Free MP3 Player)

	Portions Copyright (C) 1999 EMusic.com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	$Id: pls.h,v 1.5 2003/02/19 02:05:31 safemode Exp $
____________________________________________________________________________*/

#ifndef INCLUDED_PLS_H
#define INCLUDED_PLS_H

#include <string>


#include <assert.h>

#include "config.h"
#include "errors.h"
#include "facontext.h"

#include "playlistformat.h"
#include "playlist.h"

class PLS : public PlaylistFormat {
 public:
    PLS(FAContext *context);
    virtual ~PLS();

    virtual Error GetSupportedFormats(PlaylistFormatInfo* info, uint32_t index);
    virtual Error ReadPlaylist( const char* url, std::vector<PlaylistItem*>* items,
                                PLMCallBackFunction function = NULL,
                                void* cookie = NULL);
    virtual Error WritePlaylist(const char* url, PlaylistFormatInfo* format, 
                                std::vector<PlaylistItem*>* items,
                                PLMCallBackFunction function = NULL,
                                void* cookie = NULL); 

 private:

     void AddItem(std::vector<PlaylistItem*>* list, string &entry, 
	              string &title, int32_t len, string &root);
};



#endif // INCLUDED_PLS_H

